module Planik
  module Lohnausweis


    # Die Rohdaten um einen Lohnausweis zu generieren
    class Rohdaten

      #
      # Entspricht einer lohnrelevanten Zeile im PDF,
      # z.B. Kinderzulage: menge: 2, Ansatz: 260 Betrag wird ausgerechnet
      #
      class MengeAnsatz
        attr_accessor :menge, :ansatz

        def initialize(menge, ansatz)
          @menge, @ansatz = menge, ansatz;
        end
      end


      # Die Arbeitszeit in der Zeitspanne rohdaten#start_datum bis rohdaten#end_datum
      class Arbeitszeit
        attr_accessor :gleitzeit_vor, :soll_stunden, :ist_stunden

        def initialize(gleitzeit_vor, soll_stunden, ist_stunden)
          @gleitzeit_vor, @soll_stunden, @ist_stunden = gleitzeit_vor, soll_stunden, ist_stunden
        end
      end

      class Adresse
        attr_accessor :vorname, :name
        attr_accessor :strasse, :nummer
        attr_accessor :plz, :ort

        def initialize (voname, name, strasse, nummer, plz, ort)
          @vorname, @name, @strasse, @nummer, @plz, @ort = voname, name, strasse, nummer, plz, ort
        end

        def voller_name
          "#{vorname} #{name}"
        end

        def plz_ort
          "#{plz} #{ort}"
        end

        def strasse_nr
          "#{strasse} #{nummer}"
        end

      end

      #
      # Ein Dienst, Termine mit Arbeitszeit oder "andere Arbeit". Erscheinen im Anhang des PDFs
      #
      class ArbeitsItem
        attr_accessor :daten
        def initialize(daten)
          @daten = daten
        end

        def get was
          daten[was]

        end

      end

      attr_accessor :start_datum, :end_datum
      attr_accessor :adresse
      attr_accessor :arbeitszeit
      attr_accessor :geldbetraege_zulagen_anzeigen
      attr_accessor :zulage_nacht, :zulage_wochenende
      attr_accessor :arbeitsliste_spalten
      attr_accessor :arbeitsliste

      def initialize
        @arbeitsliste = []
        yield self
      end
    end
  end
end


